try:
	import psyco
	psyco.full()
except:
	pass

import sqlite3 as sqlite
import sys

print 'version 2.0'
if len(sys.argv) < 4:
	print 'usage: python %s dbfile infile outfile goodfile [startField]' % sys.argv[0]
	sys.exit(1)

dbfile = sys.argv[1]
filename = sys.argv[2]
startField = 0
outfile = open(sys.argv[3],'w')
goodfile = open(sys.argv[4],'w')
if len(sys.argv) > 5:
	startField = int(sys.argv[5])
if startField < 0:
	startField = 0
db = sqlite.connect(dbfile)
sql = db.cursor()

file = open(filename)
featureList = []
featureDict = {}

for line in file:
	fields = line.strip().split('\t')
	chrom = fields[startField][3:]
	start = int(fields[startField + 1])
	stop = int(fields[startField + 2])
	featureList.append((chrom,start, stop))
	featureDict[(chrom, start, stop)] = line.strip()
featureList.sort()
currentChrom=''
for (chrom, start, stop) in featureList:
	if chrom != currentChrom:
		currentChrom = chrom
		try:
			del con
		except:
			pass
		con = sqlite.connect(":memory:")
		sql.execute('select name, family, start, stop from repeats where chrom = "%s" order by start' % chrom)
		results = sql.fetchall()
		results2 = []
		con.execute("create table repeats(name, family, start, stop)")
		for (name, family, rstart, rstop) in results:
			results2.append((name, family, int(rstart), int(rstop)))
		con.executemany("insert into repeats(name, family, start, stop) values (?,?,?,?)", results2)
		print chrom, len(results2)
		sql2 = con.cursor()
	featureLength = abs(stop - start)
	results = []
	finalresults = []
	sql2.execute('select name, family, start, stop from repeats where start < %d and stop > %d' % (start, start))
	results = sql2.fetchall()
	for (name, family, rstart, rstop) in results:
		overlapLength = float(abs(rstop - start))
		if overlapLength > featureLength:
			overlapLength = featureLength
		ratio = overlapLength / featureLength
		if (name, family, ratio) not in finalresults:
			finalresults.append((name, family, ratio))
	sql2.execute('select name, family, start, stop from repeats where start < %d and stop > %d' % (stop, stop))
	results = sql2.fetchall()
	for (name, family, rstart, rstop) in results:
		overlapLength = float(abs(rstart - stop))
		if overlapLength > featureLength:
			overlapLength = featureLength
		ratio = overlapLength / featureLength
		if (name, family, ratio) not in finalresults:
			finalresults.append((name, family, ratio))
	sql2.execute('select name, family, start, stop from repeats where start <= %d and stop >= %d' % (start, stop)) 
	results = sql2.fetchall()
	for (name, family, rstart, rstop) in results:
		overlapLength = float(abs(rstop - rstart))
		if overlapLength > featureLength:
			overlapLength = featureLength
		ratio = overlapLength / featureLength
		if (name, family, ratio) not in finalresults:
			finalresults.append((name, family, ratio))
	sql2.execute('select name, family, start, stop from repeats where start >= %d and stop <= %d' % (start, stop)) 
	results = sql2.fetchall()
	for (name, family, rstart, rstop) in results:
		overlapLength = float(abs(rstop - rstart))
		if overlapLength > featureLength:
			overlapLength = featureLength
		ratio = overlapLength / featureLength
		if (name, family, ratio) not in finalresults:
			finalresults.append((name, family, ratio))
	line = featureDict[(chrom, start, stop)]
	total = 0.
	for (name, family, fraction) in finalresults:
		outline = '%s\t%s\t%s\t%2.2f' % (line, name, family, fraction)
		total += fraction
		print outline
		outfile.write(outline + '\n')
	if len(finalresults) == 0:
		outline = '%s\t%s\t%s\t%2.2f' % (line, 'NR', 'NR', 0.)
		print outline
		outfile.write(outline + '\n')
	if total < 0.2:
		goodfile.write(line + '\n')


