#
#  findMotifs.py
#  ENRAGE
#
try:
    import psyco
    psyco.full()
except:
    pass

import sys
print '%s: version 2.1' % sys.argv[0]

if len(sys.argv) < 4:
    print 'usage: python %s expbase regions.fsa threshold [-prefix motifprefix] [-numMotifs num] [-maxWidth bp]' % sys.argv[0]
    sys.exit(1)

expbase = sys.argv[1]
fsafile = sys.argv[2]
threshold = float(sys.argv[3])

motifPrefix = expbase
numMotifs = '10'
maxWidth = 28

if '-prefix' in sys.argv:
    motifPrefix = sys.argv[sys.argv.index('-prefix') + 1]

if '-numMotifs' in sys.argv:
    numMotifs = sys.argv[sys.argv.index('-numMotifs') + 1]

if '-maxWidth' in sys.argv:
    maxWidth = int(sys.argv[sys.argv.index('-maxWidth') + 1])

from cistematic.experiments.fasta import Fasta

from cistematic.programs.meme import Meme
from cistematic.programs.alignace import AlignACE
from cistematic.programs.locator import Locator

exp = Fasta(expbase, expbase + '.db')
#exp.debugSQL = True

exp.initialize()

prog4 = Meme()
prog4.setMaxWidth(maxWidth)
prog4.setNumMotifs(numMotifs)
prog4.setModel('zoops')
exp.appendProgram(prog4)

exp.run(fsafile)

exp.createAnalysis()
exp.loadAnalysis()
exp.mapMotifs(threshold)
exp.exportMotifs(prefix = motifPrefix)

exp.draw(expbase + '.png', maxOccurences=4000)

