#
#  findall.py
#  ENRAGE
#

print 'version 2.02'
try:
	import psyco
	psyco.full()
except:
	pass

from commoncode import *
import sys

maxSpacing = 75
minHits = 8
minRatio = 5
limit = 0

if len(sys.argv) < 5:
    print 'usage: python %s factorLabel chipbedfile controlbedfile regionoutfile [minHits] [minRatio] [maxSpacing] [maxReads] [-listpeak] [-normalize] [-chipsize readCount] [-controlsize readCount]' % sys.argv[0]
    print '\n\twhere values in brackets are optional, but must be filled in the order'
    print '\tgiven, and where [maxReads] equals # of reads to use from the chip and'
    print '\tthe input control if greater than 0.\n'
    print '\tminRatio (default %d fold) is the minimum fold enrichment over the' % minRatio
    print '\tcontrol, minHits (default %d) is the minimum number of reads within' % minHits
    print '\tthe region, whereas maxSpacing (default %d bp) represents the maximum' % maxSpacing
    print '\tdistance between reads in the region.\n'
    print '\t-listpeak lists the peak of the triangular-smoothed region.\n'
    print '\t-normalize will treat all settings, ratios and report numbers on a per-million reads basis'
    sys.exit(1)

factor = sys.argv[1]
readlen = readSize(sys.argv[2], verbose=True)
hitfile = sys.argv[2]
mockfile = sys.argv[3]
outfilename = sys.argv[4]
if len(sys.argv) > 5:
    try:
        if '-' not in sys.argv[4]:
            minHits = int(sys.argv[5])
    except:
        pass
if len(sys.argv) > 6:
    try:
        if '-' not in sys.argv[5]:
            minRatio = int(sys.argv[6])
    except:
        pass
if len(sys.argv) > 7:
    try:
        if '-' not in sys.argv[6]:
            maxSpacing = int(sys.argv[7])
    except:
        pass
if len(sys.argv) > 8:
    try:
        limit = int(sys.argv[8])
    except:
        pass

listPeak = False
if '-listpeak' in sys.argv:
    listPeak = True

normalize = False
if '-normalize' in sys.argv:
    normalize = True

print 'maxSpacing = %d minHits = %d minRatio = %d limit=%d listPeak=%s' % (maxSpacing, minHits, minRatio, limit, listPeak)

mockDict = getReadDict(mockfile, limit, verbose = True)
hitDict = getReadDict(hitfile, limit, verbose = True)

mockDictSize = 1
hitDictSize = 1
if normalize:
    print 'normalizing to RPM'
    if '-controlsize' in sys.argv:
        mockDictSize = float(sys.argv[sys.argv.index('-controlsize') + 1])/1000000.
    else:
        mockDictSize = datasetSize(mockfile) / 1000000.
    if '-chipsize' in sys.argv:
        hitDictSize = float(sys.argv[sys.argv.index('-chipsize') + 1])/1000000.
    else:
        hitDictSize = datasetSize(hitfile) / 1000000.
    print mockDictSize, hitDictSize

outfile = open(outfilename,'w')

index = 0
total = 0
for chrom in hitDict:
    if chrom == 'M':
        continue
    if chrom not in mockDict:
        continue
    print 'chromosome %s' % (chrom)
    previousHit = 0
    currentHitList = []
    mockStart = 0
    numStarts = 0
    dictLen = len(hitDict[chrom])
    chromIndex = 1
    for (pos, sense) in hitDict[chrom]:
        chromIndex += 1
        if abs(pos - previousHit) > maxSpacing or chromIndex >= dictLen:
            hitListLength = len(currentHitList)
            if normalize:
                hitListLength /= hitDictSize
            if hitListLength >= minHits and numStarts > minRatio:
                numMock = 1
                mockForward = 0
                regionStart = currentHitList[0]
                regionStop = currentHitList[-1]
                for (entry, entrysense) in mockDict[chrom][mockStart:]:
                    if entry < (regionStart - readlen):
                        continue
                    elif entry > (regionStop + readlen):
                        break
                    numMock += 1
                    mockForward += 1
                if normalize:
                    numMock /= mockDictSize
                if hitListLength >= minHits and (hitListLength / numMock) >= minRatio:
                    (topPos, numHits, smoothArray, numPlus) = findPeak(hitDict[chrom], regionStart, regionStop - regionStart, readlen)
                    try:
                        plusRatio = float(numPlus)/numHits
                        if smoothArray[topPos[0]] >= 5 and 0.1 <= plusRatio <= 0.9:
                            index += 1
                            peak = ''
                            if listPeak:
                                peak= '\t%d' % (regionStart + topPos[0])
                            outline = '%s%d\tchr%s\t%d\t%d\t%d%s' % (factor, index, chrom, regionStart, regionStop + readlen - 1, hitListLength, peak)
                            print outline
                            outfile.write('%s\n' %  outline)
                            total += hitListLength
                    except:
                        pass
                mockStart += mockForward
            currentHitList = []
            numStarts = 0
        if pos not in currentHitList:
            numStarts += 1
        currentHitList.append(pos)
        previousHit = pos
print total
outfile.close()
