print 'version 1.7'
try:
	import psyco
	psyco.full()
except:
	pass

from commoncode import *
import sys

maxSpacing = 75
minHits = 20

if len(sys.argv) < 4:
	print 'usage: python %s factorLabel inputbedfile regionoutfile [minHits] [maxSpacing] [maxReads] [-strict] [-listpeak] [-fullChrom]' % sys.argv[0]
	print '\n\twhere [maxReads] is an optional # of reads to use from the bed file'
	print '\tminHits (default %d) is the minimum number of reads within the' % minHits
	print '\tregion, whereas maxSpacing (default %d bp) represents the maximum' % maxSpacing
	print '\tdistance between reads in the region.\n'
	print '\t-strict enforces a requirement for a minimum ratio of directionality'
	print '\tin reads, which is useful in getting rid of ChIPSeq artifacts.\n'
	print '\t-listpeak lists the peak of the triangular-smoothed region.\n'
	print '\tThis version of the peak-finder should not used on regular ChIPseq'
	print '\tdata, especially without the -strict option.'
	sys.exit(1)

factor = sys.argv[1]
readlen = readSize(sys.argv[2], verbose=True)
hitfile = sys.argv[2]
outfilename = sys.argv[3]
limit = 0
if len(sys.argv) > 4:
    try:
        minHits = int(sys.argv[4])
    except:
        pass
if len(sys.argv) > 5:
    try:
        maxSpacing = int(sys.argv[5])
    except:
        pass
if len(sys.argv) > 6:
    try:
        limit = int(sys.argv[6])
    except:
        pass

beStrict = False
if '-strict' in sys.argv:
    beStrict = True

listPeak = False
if '-listpeak' in sys.argv:
    listPeak = True

fullChr = False
if '-fullChrom' in sys.argv:
    fullChr = True

print 'maxSpacing = %d minHits = %d maxReads=%d strict=%s listPeak=%s' % (maxSpacing, minHits, limit, beStrict, listPeak)

hitDict = getReadDict(hitfile, limit, verbose = True, fullChrom=fullChr)

outfile = open(outfilename,'w')

index = 0
total = 0
for chrom in hitDict:
	print '%s' % (chrom)
	if chrom == 'M':
		continue
	previousHit = 0
	currentHitList = []
	numStarts = 0
	for (pos, sense) in hitDict[chrom]:
		if abs(pos - previousHit) > maxSpacing:
			if len(currentHitList) >= minHits and numStarts > 5:
				if len(currentHitList) >= minHits:
					regionStart = currentHitList[0]
					regionStop = currentHitList[-1]
					(topPos, numHits, smoothArray, numPlus) = findPeak(hitDict[chrom], regionStart, regionStop - regionStart, readlen)
					try:
						if smoothArray[topPos[0]] >= minHits/3:
							ratio = float(numPlus) / numHits
							if beStrict and 0.1 <= ratio <= 0.9:
                                                            pass
							elif beStrict:
                                                            continue
							index += 1
							peak = ''
							if listPeak:
                                                            peak = '\t%d' % (regionStart + topPos[0])
                                                        if fullChr:
                                                            outline = '%s%d\t%s\t%d\t%d\t%d%s' % (factor, index, chrom, regionStart, regionStop + readlen - 1, len(currentHitList), peak)
                                                        else:
                                                            outline = '%s%d\tchr%s\t%d\t%d\t%d%s' % (factor, index, chrom, regionStart, regionStop + readlen - 1, len(currentHitList), peak)
							print outline
							outfile.write('%s\n' %  outline)
							total += len(currentHitList)
					except:
						pass
			currentHitList = []
			numStarts = 0
		if pos not in currentHitList:
			numStarts += 1
		currentHitList.append(pos)
		previousHit = pos
print total
outfile.close()
