try:
	import psyco
	psyco.full()
except:
	print 'psyco not running'

import sys

print '%s: version 3.3' % sys.argv[0]

if len(sys.argv) < 5:
	print 'usage: python %s genome hitfile outfilename remainingbed [-searchGID] [-countfeatures]' % sys.argv[0]
	sys.exit(1)

from commoncode import *
from cistematic.genomes import Genome
from cistematic.core.geneinfo import geneinfoDB

genome = sys.argv[1]
readlen = readSize(sys.argv[2], verbose=True)
hitfile =  sys.argv[2]
outfilename = sys.argv[3]
remainingfile = open(sys.argv[4],'w')

searchGID = False
if '-searchGID' in sys.argv:
    searchGID = True

countFeats = False
if '-countfeats' in sys.argv:
    countFeats = True

hitDict = getReadDict(hitfile, verbose = True)

hg = Genome(genome)
idb = geneinfoDB(cache=True)

gidDict = {}
geneinfoDict = idb.getallGeneInfo(genome)
gidCount = {}

featuresByChromDict = getFeaturesByChromDict(hg)
seenFeaturesByChromDict = []
gidList = hg.allGIDs()

gidList.sort()
for gid in gidList:
    gidCount[gid] = 0

index = 0
for chrom in hitDict:
    if chrom not in featuresByChromDict:
        continue
    if countFeats:
        seenFeaturesByChromDict[chrom] = []
    print '\n' + chrom,
    startFeature = 0
    for (tagStart, tagSense) in hitDict[chrom]:
        index += 1
        found = False
        if index % 100000 == 0:
            print ' read %d' % index,
        stopPoint = tagStart + readlen
        if startFeature < 0:
            startFeature = 0
        for (start, stop, gid, sense, ftype) in featuresByChromDict[chrom][startFeature:]:
            if tagStart > stop:
                startFeature += 1
                continue
            if start > stopPoint:
                if not found:
                    remainingfile.write('chr%s\t%d\t%d\tread\t0\t%s\n' % (chrom, tagStart, tagStart + readlen - 1, tagSense))
                startFeature -= 100
                break
            if start <= tagStart <= stop:
                if gid in gidCount:
                    gidCount[gid] += 1
                if countFeats:
                    if (start, stop, gid, sense) not in seenFeaturesByChromDict[chrom]:
                        seenFeaturesByChromDict[chrom].append((start, stop, gid, sense))
                stopPoint = stop 
                found = True
#infile = open(infilename)
print ' '
if countFeats:
    count = 0
    for chrom in seenFeaturesByChromDict:
        count += len(seenFeaturesByChromDict[chrom])
    print 'saw %d features' % count

outfile = open(outfilename,'w')

for gid in gidList:
    symbol = 'LOC' + gid
    geneinfo = ''
    thegid = gid
    if searchGID and gid not in geneinfoDict:
        actualGeneID = idb.getGeneID(genome, gid)
        if len(actualGeneID) > 0:
            thegid = actualGeneID[1]
    try:
        geneinfo = geneinfoDict[thegid]
        symbol = geneinfo[0][0]
        #print geneinfo
    except:
        #print 'problem with %s' % (gid)
        pass
    if gid in gidCount:
        outfile.write('%s\t%s\t%d\n' % (gid, symbol, gidCount[gid]))
    else:
        outfile.write('%s\t%s\t0\n' % (gid, symbol))
#infile.close()
outfile.close()

