import sys

from cistematic.genomes import Genome
from cistematic.core.geneinfo import geneinfoDB

print 'version 2.1'

if len(sys.argv) < 3:
    print 'usage: python %s genome GOID [outfilename] [-append]'
    sys.exit(1)

genome = sys.argv[1]
GOID = sys.argv[2]

writeOut = False
if len(sys.argv) > 3:
    writeOut = True
    outfilename = sys.argv[3]

hg = Genome(genome)
idb = geneinfoDB()

geneList = hg.allGIDsbyGOID(GOID)
print len(geneList)
geneInfoList = idb.getallGeneInfo(genome)

if writeOut:
    if '-append' in sys.argv:
        outfile = open(outfilename,'a')
    else:
        outfile = open(outfilename,'w')

outList = []
for gid in geneList:
    symbol = 'LOC' + gid
    try:
        symbol = geneInfoList[gid][0][0]
    except:
        pass
    outList.append(symbol)

outList.sort()
for symbol in outList:
    if writeOut:
        outfile.write(symbol + '\n')
    else:
        print symbol

if writeOut:
    outfile.close()
