import sys
try:
	import psyco
	psyco.full()
except:
	print 'psyco not running'
from cistematic.core.motif import Motif
from cistematic.core import complement
from cistematic.genomes import Genome
from commoncode import *

print 'version 1.6'
if len(sys.argv) < 7:
	print 'usage: python %s genome motifFile motThreshold ChIPbedfile regionfile siteOutfile' % sys.argv[0]
	sys.exit(1)

genome = sys.argv[1]
motfilename = sys.argv[2]
motThreshold = int(sys.argv[3])
chipfilename = sys.argv[4]
#pvalfilename = 'pvalueunamp.txt'
infilename = sys.argv[5]
outfilename = sys.argv[6]
maxPvalue = 0.0001

mot = Motif('',motifFile = motfilename)
motLen = len(mot)
bestScore = mot.bestConsensusScore()

hg = Genome(genome)
#genomesize = getGenomesize()

regions = getMergedRegions(infilename, 500)
hitDict = getReadDict(chipfilename)

outfile = open(outfilename,'w')

countList = []
#pvalfile = open(pvalfilename)
#for line in pvalfile:
#	fields = line.split()
#	if len(fields) > 1:
#		countList.append(int(fields[1]))

posList = []

index = 0
regionList = []

for chrom in regions:
	if 'rand' in chrom or 'M' in chrom:
		continue
	for (start, stop, length) in regions[chrom]:
		regionList.append((chrom, start, length))
	
notFoundIndex = 0
for (chrom, start, length) in regionList:
        try:
            seq = hg.sequence(chrom, start, length)
        except:
            print "couldn't retrieve %s %d %d - skipping" % (chrom, start, length)
            continue
	(topPos, numHits, smoothArray, numPlus) = findPeak(hitDict[chrom], start, length)
	if len(topPos) == 0:
		print 'topPos error'
	peakpos = topPos[0]
	found = []
	matches = mot.locateMotif(seq, motThreshold)
	for (pos, sense) in matches:
		alreadyFound = False
		for (fpos, fdist) in found:
			if pos + start == fpos:
				alreadyFound = True
		if not alreadyFound:
			found.append((start + pos, pos  + motLen/2 - peakpos))
	
	foundValue = False
	for (foundpos, peakdist) in found:
		seq = hg.sequence(chrom, foundpos, motLen)
		# get a p-value
		expected = 0
		midpoint = foundpos + motLen/2
		tagcount = 0
		for (tstart, sense) in hitDict[chrom]:
			if abs(tstart - midpoint) < 200:
				tagcount += 1
			if tagcount > 199:
				tagcount = 199
				break
		#for mockcount in countList[tagcount:]:
		#	expected += mockcount
		#pval = expected / genomesize
		# reject if pvalue is not small enough
		#if pval > maxPvalue:
		#	continue
		pval = 0.01
		foundValue = True
		(front, back) = mot.scoreMotif(seq)
		sense = '+'
		if front > back:
			score = int(100 * front / bestScore)
		else:
			score = int(100 * back / bestScore)
			sense = '-'
			foundpos + 1
                        seq = complement(seq)
		#print 'chr%s:%d-%d\t%d\t%d\t%d\tchr%s:%d-%d\t%s' % (chrom, foundpos, foundpos + motLen - 1, score, numHits, peakdist, chrom, start, start + length, sense)
                print seq
		outfile.write('chr%s:%d-%d\t%d\t%d\t%d\tchr%s:%d-%d\t%s\n' % (chrom, foundpos, foundpos + motLen - 1, score, numHits, peakdist, chrom, start, start + length, sense))
	if not foundValue:
		print 'could not find a %s site for %s:%d-%d' % (mot.tagID, chrom, start, start+ length)
outfile.close()
