#
#  getfasta.py
#  ENRAGE
#

try:
    import psyco
    psyco.full()
except:
    pass

import sys
print '%s: version 2.0' % sys.argv[0]

from commoncode import *
from cistematic.genomes import Genome
from cistematic.core.geneinfo import geneinfoDB

if len(sys.argv) < 5:
    print 'usage: python %s genome hitfile regionfile [-seqradius bp] [-minreads reads] outfilename' % sys.argv[0]
    sys.exit(1)

genome = sys.argv[1]
hitfile =  sys.argv[2]
regionfile = sys.argv[3]
outfilename = sys.argv[-1]

# sequence radius
#seqsize = 500
seqsize = 50
minHits = 1

if '-seqradius' in sys.argv:
    seqsize = int(sys.argv[sys.argv.index('-seqradius') + 1])

if '-minreads' in sys.argv:
    minHits = int(sys.argv[sys.argv.index('-minreads') + 1])

hg = Genome(genome)

outfile = open(outfilename,'w')

readlen = readSize(hitfile)
hitDict = getReadDict(hitfile)
regionDict = getMergedRegions(regionfile, 500)

ncregions = {}
for chrom in regionDict:
    ncregions[chrom] = []

index = 0

for chrom in regionDict:
    for (rstart, rstop, rlen) in regionDict[chrom]:
        try:
            seq = hg.sequence(chrom, rstart - 5000, rlen + 10000)
        except:
            print 'problem with %s' % str((rstart, rstop, rlen))
            continue
        (topPos, numHits, smoothArray, numPlus) = findPeak(hitDict[chrom], rstart, rlen, readlen)
        if numHits > minHits:
            ncregions[chrom].append((rstart, rstop, rlen, topPos, numHits))
            index += 1

currentIndex = 1
for chrom in ncregions:
    for (rstart, rstop, rlen, topPos, numHits) in ncregions[chrom]:
        print (chrom, rstart, rstop, rlen, str(topPos), numHits)
        newrstart = rstart + topPos[0] - seqsize
        seq2 = hg.sequence(chrom, newrstart, 2 * seqsize + 1)
        #seq2 = hg.sequence(chrom, newrstart, 101, maskCDS=True, maskLower=True)
        outfile.write('>chr%s:%d-%d\n%s\n' % (chrom, newrstart, newrstart + 2 * seqsize, seq2))
outfile.close()
