import sys
from commoncode import *

print '%s: version 1.0' % sys.argv[0]
if len(sys.argv) < 6:
	print 'usage: python %s locusFile mrnaFile ExpandedRPKM bedfile outfile' % sys.argv[0]
	sys.exit(1)

locusFile = open(sys.argv[1])
mrnaFile = open(sys.argv[2])
rpkmFile = open(sys.argv[3])
bedSize = datasetSize(sys.argv[4]) / 1000000.
outfile = open(sys.argv[5],'w')

mrnaCount = {}
for line in mrnaFile:
	fields = line.strip().split()
	mrnaCount[fields[1]] = int(fields[2])

mrnaLengthDict = {}
rpkmDict = {}
for line in rpkmFile:
	fields = line.strip().split()
	mrnaLengthDict[fields[1]] = float(fields[2])
	rpkmDict[fields[1]] = float(fields[-1])

for line in locusFile:
	fields = line.strip().split()
	symbol = fields[1]
	intronLength = float(fields[3])/1000. - mrnaLengthDict[symbol]
	totalCount = int(fields[2])
	if intronLength < 1 or totalCount < 1:
		continue
	diffCount = totalCount - mrnaCount[symbol]
	diffFraction = float(diffCount) / totalCount 
	intronRPK = diffCount / intronLength
	intronRPKM = intronRPK / bedSize 
	try:
		rpkmRatio = intronRPKM/rpkmDict[symbol]
	except:
		rpkmRatio = -1
	outfile.write('%s\t%s\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\n' % (fields[0], symbol, rpkmDict[symbol], intronLength, intronRPKM, diffFraction, rpkmRatio))
