import sys
print 'version 1.2'

if len(sys.argv) < 3:
	print 'usage: python %s sitefile outbedfile [-noheader] [-stype fieldID]' % sys.argv[0]
	sys.exit(1)

stypeID = 4
if '-stype' in sys.argv:
    stypeID = int(sys.argv[sys.argv.index('-stype') + 1])
infile = open(sys.argv[1])
outfile = open(sys.argv[2],'w')

(name, extension) = sys.argv[2].split('.')
if '-noheader' not in sys.argv:
    outfile.write('track name="%s"\n' % name)

for line in infile:
    fields = line.split()
    (chrom, loc) = fields[0].split(':')
    (start, stop) = loc.split('-')
    score = fields[1]
    stype = 'reg'
    try:
        stype = fields[stypeID]
        if stype == '11':
            stype = 'can'
        elif stype == '0':
            stype = 'half'
        else:
            stype = 'NC' + stype
    except:
        pass
    sense = fields[-1].strip()
    outfile.write('%s\t%s\t%d\t%s\t%s\t%s\n' % (chrom, start, int(stop) + 1, stype, score, sense))
outfile.close()
