import sys

print 'version 1.3'
if len(sys.argv) < 4:
	print 'usage: python %s filename trackDesc outfilename' % sys.argv[0]
	sys.exit(1)

filename = sys.argv[1]
trackDesc = sys.argv[2]
outfilename = sys.argv[3]

readsize = 0
padsize = 0
index = 0

infile = open(filename,'r')
#infile.readline()

outfile = open(outfilename,'w')
outfile.write('track name="%s" visibility=4 itemRgb="On"\n' % trackDesc)

for line in infile:
	if 'NM' in line or 'splice' in line or 'QC' in line:
		continue
	fields = line.split()
	if readsize == 0:
		readsize = len(fields[1]) - 1
	if readsize > 31:
		padsize = readsize - 31
	#(chrom, start) = fields[3].split(':')
	#sense = fields[4]
	(zero, one, two) = fields[2].split(':')
	zero = int(zero)
	one = int(one)
	two = int(two)
	bestMatch = [False, False, False]
	if zero == 1:
		bestMatch[0] = True
	elif zero == 0 and one == 1:
		bestMatch[1] = True
	elif zero == 0 and one == 0 and two == 1:
		bestMatch[2] = True
	else:
		continue
	bestpos = []
	pos = fields[3].split(',')
	if len(pos) == 1:
		if 'splice' in pos:
			continue
		bestpos = pos
	else:
		currentChr = ''
		for apos in pos:
			if 'splice' in apos:
				continue
			if ':' in apos:
				(front, back) = apos.split(':')
				currentChr = front
			else:
				apos = currentChr + ':' + apos
			matchType = int(apos[-1])
			if bestMatch[matchType]:
				bestpos.append(apos)
	for apos in bestpos:
		try:
			(chrom, back) = apos.split(':')
		except:
			print apos
			continue
		if '/' in chrom:
			chromfields = chrom.split('/')
			chrom = chromfields[-1]
		if '.' in chrom:
			(chrom, fileExt) = chrom.split('.')
		start = int(back[:-2])
		sense = back[-2]
		if sense == 'F':
			sense = '+'
			senseCode = '0,0,255'
		else:
			start = start - padsize
			sense = '-'
			senseCode = '255,0,0'
		stop = int(start) + readsize
		outfile.write('%s %d %d read 0 %s - - %s\n' % (chrom, start, stop, sense, senseCode))
		index += 1
outfile.close()
print index
