try:
	import psyco
	psyco.full()
except:
	pass

import sys
print '%s: version 1.1' % sys.argv[0]
if len(sys.argv) < 7:
	print 'usage: python %s genome uniqbedfile multibedfile uniqcountfile multicountfile outfile\n' % sys.argv[0]
	sys.exit(1)

from cistematic.core.geneinfo import geneinfoDB
from commoncode import *

genome = sys.argv[1]
uniquebedfilename = sys.argv[2]
multibedfilename = sys.argv[3]
uniqcountfile = open(sys.argv[4])
multicountfile = open(sys.argv[5])

bedcount = datasetSize(uniquebedfilename, verbose=True)
multicount = datasetSize(multibedfilename, verbose=True, countLabels=True)
countDict = {}
lengthDict = {}
geneList = []

totalCount = (bedcount + multicount) / 1000000.
idb = geneinfoDB(cache=True)

gidDict = {}
geneinfoDict = idb.getallGeneInfo(genome)
symbolToGidDict = {}

for gid in geneinfoDict:
	symbol = geneinfoDict[gid][0][0].strip()
	symbolToGidDict[symbol] = gid

outfile = open(sys.argv[6],'w')

for line in uniqcountfile:
	fields = line.strip().split()
	countDict[fields[1]] = float(fields[2]) 
        lengthDict[fields[1]] = float(fields[3]) / 1000.
	geneList.append(fields[1])
uniqcountfile.close()

for line in multicountfile:
	fields = line.strip().split()
        gene = fields[1]
        if 'LOCFAR' in gene:
            gene = gene[3:]
        try:
            countDict[gene] += float(fields[-1])
        except:
            print 'problem with gene %s' % gene
multicountfile.close()

for gene in geneList:
	if 'LOC' in gene:
            gid = gene[3:]
        elif 'FAR' in gene:
            gid = gene
	else:
            gid = symbolToGidDict[gene]
	#rpkm is rpm / geneLength in kb.
	rpm = countDict[gene] / totalCount
	rpkm = rpm / lengthDict[gene]
	outfile.write('%s\t%.3f\t%.2f\n' %  (gene, lengthDict[gene], rpkm))
outfile.close()
