#
#  regionCounts.py
#  ENRAGE
#

try:
    import psyco
    psyco.full()
except:
    print 'psyco not running'

import sys
print '%s: version 2.0' % sys.argv[0]

if len(sys.argv) < 4:
    print 'usage: python %s regionfile hitfile outfilename [remainingbed] [fieldNum] [-normalize] [-padregion bp] [-mergeregion bp]' % sys.argv[0]
    sys.exit(1)

from commoncode import *

regionfilename = sys.argv[1]
readlen = readSize(sys.argv[2], verbose=True)
hitfile =  sys.argv[2]
outfilename = sys.argv[3]

remainingfilename = False
if len(sys.argv) > 4:
    if '-' not in sys.argv[4]:
        remainingfilename = sys.argv[4]
        remainingfile = open(remainingfilename,'w')

cField = 1
if len(sys.argv) > 5:
    if '-' not in sys.argv[4]:
        cField = int(sys.argv[5])

if '-normalize' in sys.argv:
    normalize = True
else:
    normalize = False

padregion = 0
if '-padregion' in sys.argv:
    padField = sys.argv.index('-padregion') + 1
    padregion = int(sys.argv[padField])
    print 'padding %d bp on each side of a region' % padregion

mergeregion = 0
if '-mergeregion' in sys.argv:
    mergeField = sys.argv.index('-mergeregion') + 1
    mergeregion = int(sys.argv[mergeField])
    print 'merging regions closer than %d bp' % mergeregion

regionDict = getMergedRegions(regionfilename, maxDist = mergeregion, keepLabel = True, verbose = True, chromField = cField, pad=padregion)
labelList = []
labeltoRegionDict = {}
regionCount = {}

hitDict = getReadDict(hitfile, verbose=True)
index = 0
for chrom in hitDict:
    if chrom not in regionDict:
        continue
    for (label, start, stop, length) in regionDict[chrom]:
        regionCount[label] = 0
        labelList.append(label)
        labeltoRegionDict[label] = (chrom, start, stop)
    print '\n' + chrom + ' ',
    startFeature = 0
    for (tagStart, tagSense) in hitDict[chrom]:
        index += 1
        found = False
        if index % 100000 == 0:
            print 'read %d ' % index,
        stopPoint = tagStart + readlen
        if startFeature < 0:
            startFeature = 0
        for (label ,start, stop, length) in regionDict[chrom][startFeature:]:
            if tagStart > stop:
                startFeature += 1
                continue
            if start > stopPoint:
                if not found and remainingfilename:
                    remainingfile.write('chr%s\t%d\t%d\tread\t0\t%s\n' % (chrom, tagStart, tagStart + readlen - 1, tagSense))
                startFeature -= 100
                break
            if start <= tagStart <= stop:
                regionCount[label] += 1
                stopPoint = stop 
                found = True
#infile = open(infilename)
if normalize:
    bedSize = datasetSize(hitfile)
    normalizationFactor = bedSize / 1000000.
    print normalizationFactor
    for label in regionCount:
        print regionCount[label]
        regionCount[label] = float(regionCount[label]) / normalizationFactor

outfile = open(outfilename,'w')


for label in labelList:
    (chrom, start, stop) = labeltoRegionDict[label]
    if normalize:
        outfile.write('%s\tchr%s\t%d\t%d\t%f\n' % (label, chrom, start, stop, regionCount[label]))
    else:
        outfile.write('%s\tchr%s\t%d\t%d\t%d\n' % (label, chrom, start, stop, regionCount[label]))

#infile.close()
outfile.close()

