try:
	import psyco
	psyco.full()
except:
	pass
from commoncode import *
import sys

print 'version 1.2'

if len(sys.argv) < 6:
	print 'usage: python %s bedfile1 regionfile1 bedfile2 regionfile2 outfile [rejectFile1] [rejectFile2]' % sys.argv[0]
	sys.exit(1)

readOneName =  sys.argv[1]
regionOneName = sys.argv[2]
readTwoName = sys.argv[3]
regionTwoName = sys.argv[4]

#mergedist=200
mergedist=500

outfilename = sys.argv[5]
outfile = open(outfilename, 'w')

doReject = False
if len(sys.argv)  == 8:
	doReject = True
	print 'using reject files %s %s' % (sys.argv[6], sys.argv[7])
	rejectOne = open(sys.argv[6],'w')
	rejectTwo = open(sys.argv[7],'w')

oneDict = getMergedRegions(regionOneName, mergedist, verbose=True)
twoDict = getMergedRegions(regionTwoName, mergedist, verbose=True)

oneReads = getReadDict(readOneName)
twoReads = getReadDict(readTwoName)

commonRegions = 0
oneRejectIndex = 0
twoRejectIndex = 0

onePeaksDict = {}
oneFoundDict = {}
twoPeaksDict = {}

for chrom in oneDict:
	if chrom not in twoDict:
		continue
	print chrom
	onePeaksDict[chrom] = []
	oneFoundDict[chrom] = []
	for (start, stop, length) in oneDict[chrom]:
		(topPos, numHits, smoothArray, numPlus) = findPeak(oneReads[chrom], start, length)
		onePeaksDict[chrom].append((topPos[0] + start, length/2, start, stop, numHits))
	for (start, stop, length) in twoDict[chrom]:
		(topPos, numHits, smoothArray, numPlus) = findPeak(twoReads[chrom], start, length)
		twoIsCommon = False
		twoPeak = topPos[0] + start
		twoRadius = length/2
		for (onePeak, oneRadius, ostart, ostop, ohits) in onePeaksDict[chrom]:
			if abs(twoPeak - onePeak) < (twoRadius + oneRadius):
				if (onePeak, oneRadius, ostart, ostop, ohits) not in oneFoundDict:
					oneFoundDict[chrom].append((onePeak, oneRadius, ostart, ostop, ohits))
				twoIsCommon = True
				commonRegions += 1
				outline = 'common%d\tchr%s\t%d\t%d\t%d\tchr%s\t%d\t%d\t%d' % (commonRegions, chrom, ostart, ostop, ohits, chrom, start, stop, numHits)
				#print outline
				outfile.write(outline + '\n')
		if doReject and not twoIsCommon:
			twoRejectIndex += 1
			rejectTwo.write('reject%d\tchr%s\t%d\t%d\t%d\n' % (twoRejectIndex, chrom, start, stop, numHits))

if doReject:
	for (onePeak, oneRadius, ostart, ostop, ohits) in onePeaksDict[chrom]:
		if (onePeak, oneRadius, ostart, ostop, ohits) not in oneFoundDict[chrom]:
			oneRejectIndex += 1
			rejectOne.write('reject%d\tchr%s\t%d\t%d\t%d\n' % (oneRejectIndex, chrom, ostart, ostop, ohits))
print commonRegions



