import sys
genedatafilename = 'knownGene.txt'
readsize = int(sys.argv[1])
mapfilename = sys.argv[2]
trackname = sys.argv[3]
trackdescription = sys.argv[4]
outfilename = sys.argv[5]

geneDict = {}
mapDict = {}
maxBorder = readsize - 4

genedatafile = open(genedatafilename)
for line in genedatafile:
	fields = line.strip().split('\t')
	blockCount = int(fields[7])
	if blockCount < 2:
		continue
	uname = fields[0]
	chrom = fields[1]
	sense = fields[2]
	chromstarts = fields[8][:-1].split(',')
	chromstops = fields[9][:-1].split(',')
	exonLengths = []
	totalLength = 0
	for index in range(blockCount):
		chromstarts[index] = int(chromstarts[index])
		chromstops[index] = int(chromstops[index])
		exonLengths.append(chromstops[index] - chromstarts[index])
		totalLength += exonLengths[index]
	geneDict[uname] = (sense, blockCount, totalLength, chrom, chromstarts, exonLengths)
	mapDict[uname] = []
genedatafile.close()


outfile = open(outfilename, 'w')
outfile.write('track name="%s" description="%s"\n' % (trackname, trackdescription))
index = 0
mapfile = open(mapfilename)
for line in mapfile:
	fields = line.strip().split()
	if 'U' not in fields[2]:
		continue
	(uname, spliceID,sstart) = fields[6].split(':')
	try:
		uname = uname.split('/')[1]
	except:
		print uname
	if uname not in geneDict:
		print fields
		continue
	pos = int(fields[7]) - 2
	if 0 < pos < maxBorder:
		pass
	else:
		continue
	spliceID = int(spliceID)
	spliceCount = 0
	cumulative = 0
	(sense, blockCount, transLength, chrom, chromstarts, blockSizes) = geneDict[uname]
	while cumulative < int(sstart):
		cumulative += blockSizes[spliceCount]
		spliceCount += 1
	#if sense == '-':
	#	pos = transLength - int(sstart) - pos - readsize
	lefthalf = maxBorder - pos - 1
	if lefthalf < 1 or lefthalf > maxBorder:
		continue	
	righthalf = readsize - lefthalf
	readstart = chromstarts[spliceID] + blockSizes[spliceID] - lefthalf
	readstop = chromstarts[spliceID + 1] + righthalf
	readSizes = '%d,%d' % (lefthalf, righthalf)
	readCoords = '0,%d' % (readstop - readstart - righthalf)
	readName = uname + '-' + str(pos)
	outline = '%s\t%d\t%d\t%s\t1000\t%s\t-\t-\t-\t2\t%s\t%s\n' % (chrom, readstart, readstop, readName, sense, readSizes, readCoords)
	outfile.write(outline)
mapfile.close()
outfile.close()

