try:
    import psyco
    psyco.full()
except:
    pass

import matplotlib
matplotlib.use('Agg')

from pylab import *
import math
import sys

doLog = False

print 'version 1.4'
if len(sys.argv) < 6:
    print 'usage: python %s xaxisLabel xaxisRegions yaxisLabel yaxisTags outImageName [-doLog]' % sys.argv[0]
    sys.exit(1)

if '-doLog' in sys.argv:
    doLog = True

# infilename is regions for x axis, tagfilename is for y axis
xaxis = sys.argv[1]
infilename = sys.argv[2]
yaxis = sys.argv[3]
tagfilename = sys.argv[4]
outfilename = sys.argv[5]
figtitle = '%s vs %s' % (yaxis, xaxis)

newscores = []
oldscores = []
infile = open(infilename)
tagfile = open(tagfilename)
tagDict = {}

tagfile.readline()
for line in tagfile:
    fields = line.strip().split()
    chrom = fields[0][3:].replace('_random','rand')
    if chrom not in tagDict:
        tagDict[chrom] = []
    tagDict[chrom].append(int(fields[1]))

tagDictKeys = tagDict.keys()
for chrom in tagDictKeys:
    tagDict[chrom].sort()

for line in infile:
    fields = line.strip().split()
    try:
        chrom = fields[1][3:]
    except:
        print line
        continue
    start = int(fields[2])
    stop = int(fields[3])
    if chrom not in tagDictKeys:
        continue
    score = float(fields[4])
    if doLog:
        score = math.log(score, 10)
    newscore = 0
    for tag in tagDict[chrom]:
        if tag + 25 < start:
            continue
        if tag > stop:
            break
        newscore += 1
    if doLog:
        try:
            newscore = math.log(newscore, 10)	
        except:
            newscore = 0.1
    print score, newscore
    oldscores.append(score)
    newscores.append(newscore)

title(figtitle)
plot(oldscores, newscores, 'b,')
m, b = polyfit(oldscores, newscores, 1)
print m
print b
oldscores.sort()
plot([oldscores[0], oldscores[-1]], [m * oldscores[0] + b, m * oldscores[-1] + b], '-k', linewidth=2)

#fitOrder = 1
#fitvalues = polyfit(oldscores, newscores, fitOrder)
#print fitvalues
#fitvalues = polyfit(oldscores, newscores, 1)
print len(oldscores)

meanObserved = float(sum(newscores)) / len(newscores)
predicted = [(m * x + b) for x in oldscores]


meanPredicted = float(sum(predicted)) / len(predicted)
SSt = 0.
SSe = 0.

for index in range(len(newscores)):
    SSt += (newscores[index] - meanObserved) ** 2
    SSe += (newscores[index] - predicted[index]) ** 2

print SSe 
print SSt

rSquared = 1. - SSe / SSt
print 'R**2 = %f' % rSquared

if doLog:
    ylabel('log10(' + yaxis + ')')
    xlabel('log10(' + xaxis + ')')
else:
    ylabel(yaxis)
    xlabel(xaxis)
    #ylim(0,3000)
savefig(outfilename)
